/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code in this file as it was released upon
 * September 13, 2001.
 * 
 * The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
 * all Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
 * by Henk-Johan van Rantwijk. All Rights Reserved.
 * 
 * Contributor(s):
 *   David Perry <d.perry@utoronto.ca> (original author)
 *   Henk-Johan van Rantwijk <bugs4hj@netscape.net> (changed for tabList)
 * 
*/

////////////////////////////////////////////////////////////////////////////////
function tabListInit()
{
  var tabbrowser = window.arguments[0];
  var tabList = tabbrowser.mTabList;
  var tabs = tabList.length;
  var tabURI = null;

  for (var i = 0; i < tabs; i++) {
    var tab = tabList[i];
    var browser = tabbrowser.getBrowserForTab(tab);
    var tabName = tab.getAttribute("label");
    try {
      tabURI = browser.webNavigation.currentURI.spec;
    } catch(ex) {
      tabURI = tab.getAttribute("firstpage");
    }
    createCell((i+1), tabName, tabURI, i);
  }
  sizeToContent();
}
////////////////////////////////////////////////////////////////////////////////
function createCell(tabIndex, tabName, tabURL, tabNumber)
{
  var treeKids  = document.getElementById("tabList");
  var row       = document.createElement("treerow");
  var indexCell = document.createElement("treecell");
  var nameCell  = document.createElement("treecell");
  var URIcell   = document.createElement("treecell");
  var item      = document.createElement("treeitem");

  indexCell.setAttribute("label", tabIndex);
  nameCell.setAttribute("label", tabName);
  URIcell.setAttribute("label", tabURL);

  row.appendChild(indexCell);
  row.appendChild(nameCell);
  row.appendChild(URIcell);

  item.setAttribute("id", tabNumber);
  item.appendChild(row);

  treeKids.appendChild(item);
}
////////////////////////////////////////////////////////////////////////////////
function tabListClick()
{
  var tabbrowser = window.arguments[0];
  var index = document.getElementById("tabListTree").currentIndex;
  tabbrowser.selectedTab = tabbrowser.mTabList[index];
  window.close();
}
